----------------------------------------------------------------------------
-- mod 239 reducer (mod_239_reducer.vhd)
--
-- reduce a 16 bits input modulo 239
----------------------------------------------------------------------------
library ieee; use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity mod_239_reducer is
port(
  x: in std_logic_vector(15 downto 0);
  z: out std_logic_vector(7 downto 0)
);
end mod_239_reducer;

architecture circuit of mod_239_reducer is
  signal x1_by_17, x0, sum, xx1_by_17, xx0, xxx: std_logic_vector(8 downto 0);
  signal long_xxx, minus_239, dif: std_logic_vector(9 downto 0);
  signal x2_by_33, long_sum, xx: std_logic_vector(9 downto 0);
begin
  x1_by_17 <= '0' & x(11 downto 8) & x(11 downto 8);
  x0 <= '0' & x(7 downto 0);
  sum <= x1_by_17 + x0;
  x2_by_33 <= '0' & x(15 downto 12) & '0' & x(15 downto 12);
  long_sum <= '0' & sum;
  xx <= x2_by_33 + long_sum;
  xx1_by_17 <= "000" & xx(9 downto 8) & "00" & xx(9 downto 8);
  xx0 <= '0' & xx(7 downto 0);
  xxx <= xx1_by_17 + xx0;
  minus_239 <= conv_std_logic_vector(273, 10);
  long_xxx <= '0' & xxx;
  dif <= long_xxx + minus_239;
  with dif(9) select z <= dif(7 downto 0) when '1', xxx(7 downto 0) when others;
end circuit;

